#include "PainterEngine_Application.h"
PX_Application App;

px_bool PX_ApplicationInitialize(PX_Application *pApp,px_int screen_width,px_int screen_height)
{
	px_int x, y;
	PX_ApplicationInitializeDefault(&pApp->runtime, screen_width, screen_height);
	//رͼƬ
	if (!PX_LoadTextureFromFile(&pApp->runtime.mp_resources, &pApp->background, "assets/background.traw"))return PX_FALSE;
	//رװ
	if (!PX_LoadTextureFromFile(&pApp->runtime.mp_resources, &pApp->backgroundornament, "assets/backgroundornament.traw"))return PX_FALSE;
	//ͼƬ
	if (!PX_LoadTextureFromFile(&pApp->runtime.mp_resources, &pApp->character, "assets/character.traw"))return PX_FALSE;
	//ͼƬ
	if (!PX_LoadTextureFromFile(&pApp->runtime.mp_resources, &pApp->strings, "assets/strings.traw"))return PX_FALSE;

	//ΪͼƬͼƬHSLͼƬڴ
	pApp->background_hsl = MP_Malloc(&pApp->runtime.mp_resources, pApp->background.width * pApp->background.height * sizeof(px_color_hsl));
	pApp->strings_hsl = MP_Malloc(&pApp->runtime.mp_resources, pApp->strings.width * pApp->strings.height * sizeof(px_color_hsl));

	//RGBͼƬתӳ䵽HSL
	for (y=0;y< pApp->background.height;y++)
	{
		for (x=0;x< pApp->background.width;x++)
		{
			pApp->background_hsl[y * pApp->background.width + x] = PX_ColorRGBToHSL(PX_SURFACECOLOR(&pApp->background, x, y));
		}
	}

	for (y = 0; y < pApp->strings.height; y++)
	{
		for (x = 0; x < pApp->strings.width; x++)
		{
			pApp->strings_hsl[y * pApp->strings.width + x] = PX_ColorRGBToHSL(PX_SURFACECOLOR(&pApp->strings, x, y));
		}
	}

	return PX_TRUE;
}

px_void PX_ApplicationUpdate(PX_Application *pApp,px_dword elpased)
{
	px_int x, y;
	px_int inc;
	static px_dword elpased_step = 0;
	elpased_step += elpased;

	//ÿ10,HSLеɫ+1,
	if (elpased_step>=10)
	{
		inc = elpased_step / 10;
		elpased_step %= 10;
	}
	else
	{
		return;
	}

	for (y = 0; y < pApp->background.height; y++)
	{
		for (x = 0; x < pApp->background.width; x++)
		{
			//ɫ
			pApp->background_hsl[y * pApp->background.width + x].H += inc;
			//ɫķΧΪ0-360,360ķΧӦȡԼȥ
			pApp->background_hsl[y * pApp->background.width + x].H = (px_float)((px_int)pApp->background_hsl[y * pApp->background.width + x].H%360);
			//ȾҪRGB,ҪHSLתRGB
			PX_SURFACECOLOR(&pApp->background, x, y)= PX_ColorHSLToRGB(pApp->background_hsl[y * pApp->background.width + x]);
		}
	}

	for (y = 0; y < pApp->strings.height; y++)
	{
		for (x = 0; x < pApp->strings.width; x++)
		{
			//ɫ
			pApp->strings_hsl[y * pApp->strings.width + x].H += inc;
			//ɫķΧΪ0-360,360ķΧӦȡԼȥ
			pApp->strings_hsl[y * pApp->strings.width + x].H = (px_float)((px_int)pApp->background_hsl[y * pApp->strings.width + x].H % 360);
			//ȾҪRGB,ҪHSLתRGB
			PX_SURFACECOLOR(&pApp->strings, x, y) = PX_ColorHSLToRGB(pApp->strings_hsl[y * pApp->strings.width + x]);
		}
	}
}

px_void PX_ApplicationRender(PX_Application *pApp,px_dword elpased)
{
	px_surface *pRenderSurface=&pApp->runtime.RenderSurface;
	//Ʊ
	PX_TextureRender(pRenderSurface, &pApp->background, 0, 0, PX_ALIGN_LEFTTOP, PX_NULL);
	//Ʊװ
	PX_TextureRender(pRenderSurface, &pApp->backgroundornament, 0, 0, PX_ALIGN_LEFTTOP, PX_NULL);
	//
	PX_TextureRender(pRenderSurface, &pApp->character, pApp->background.width, pApp->background.height, PX_ALIGN_RIGHTBOTTOM, PX_NULL);
	//
	PX_TextureRender(pRenderSurface, &pApp->strings, 0, 0, PX_ALIGN_LEFTTOP, PX_NULL);
}

px_void PX_ApplicationPostEvent(PX_Application *pApp,PX_Object_Event e)
{
	
}

